import { ITestBase } from '../common/types.ts';
import { stdAssert } from './deps.ts';
const {
	assertEquals,
	assertExists,
	assertInstanceOf,
	assertNotEquals,
	assertStrictEquals,
} = stdAssert;

export function testSuite(testObj: any) {
	Object.keys(testObj).forEach((group) => {
		const groupObj = testObj[group];
		Object.keys(groupObj).forEach((testName) => {
			Deno.test(testName, groupObj[testName]);
		});
	});
}

const DenoTestBase: ITestBase = {
	assertEquivalent: assertEquals,
	assertExists,
	assertInstanceOf,
	assertNotEquals,
	assertEquals: assertStrictEquals,
	assertTrue: (actual: boolean) => assertStrictEquals(actual, true),
	assertFalse: (actual: boolean) => assertStrictEquals(actual, false),
	testSuite,
};

export default DenoTestBase;
